=begin
###
Name:        AddPage.rb
Description: Displays scene [page] name[s] on screen on its own layer
Author:      TIG (c) 2005-2011
Usage:       Menu Plugins > Add Scene Name - to current scene
             or > Add Scene Names [ALL] - to do it en mass to all scenes
Date:        19/8/5
History: 1.0 first issue.
 		 1.1 layer setting adjusted. 15/07/06
         1.2 layer visibility adjusted. 16/06/07
		 1.3 layer off in all but this page. 05/11/07
         1.4 general code tidy AddPage.to_all added. 20110810
###
=end
###
require 'sketchup.rb'
###
class AddPageName

def initialize(one=true)### false does all pages
    @layerprefix = "-PAGE-" ### edit these 3 to suit your requirements ###
    @posX = 44 ### % x to locn at btm cntr of screen ###
    @posY = 98 ### % y to locn at btm cntr of screen ###
   	@model=Sketchup.active_model
    @pages=@model.pages
	if not @pages[0]
	  UI.messagebox("There are NO Pages:Scenes !")
	  return nil
	end
    @layers=@model.layers
    @model.start_operation("AddPageName")
    if one
      @page=@pages.selected_page
	  @pagename=@page.name
   	  self.process()
	  UI.messagebox("The Page:Scene Name \t\" #{@pagename} \"\nhas been put on Layer \t\"#{@pagelayer.name}\"\n\nNote that this Layer will be 'ON' only for this Page:Scene:\nby default it's 'OFF' in all others (including any new ones)\n")
    else
      @pages.each{|p|
        @page=p
        @pagename=@page.name
        self.process()
      }
    end
    @model.commit_operation
end
def process()
    @pagelayer=@layers.add(@layerprefix+@pagename)
	@pagelayer.page_behavior=LAYER_IS_HIDDEN_ON_NEW_PAGES###
    @model.pages.each{|p|p.set_visibility(@pagelayer, false)}###
	@page.set_visibility(@pagelayer, true)###
	@pagetxt=@model.add_note(@pagename, @posX.to_f/100.to_f, @posY.to_f/100.to_f)
	@pagetxt.layer=@pagelayer
end
end ### class
#----------------------------------------------------------------------------
# add menu items
if not file_loaded?(File.basename(__FILE__))
  if $submenu7
    $submenu7.add_item("Add Scene Name"){AddPageName.new(true)}
    $submenu7.add_item("Add Scene Names [ALL]"){AddPageName.new(false)}
  else
    UI.menu("Plugins").add_item("Add Scene Name"){AddPageName.new(true)}
    UI.menu("Plugins").add_item("Add Scene Names [ALL]"){AddPageName.new(false)}
  end
end
file_loaded(File.basename(__FILE__))

#----------------------------------------------------------------------------
